﻿
Imports System.IO.Ports

Module Module_COM

    Friend WithEvents ComPort As New SerialPort()

    Friend Sub COM_Open(ByVal PortName As String, ByVal BaudRate As Int32)
        If PortName = "" Then PortName = "COM1"
        If BaudRate < 600 Then BaudRate = 600
        ' -------------------------------------------- If the port is Open then close it
        COM_Close()
        ComPort.PortName = PortName
        ComPort.BaudRate = BaudRate
        ComPort.DataBits = 8
        ComPort.Parity = Parity.None
        ComPort.StopBits = StopBits.One
        ' -------------------------------------------- Set params
        ComPort.ReceivedBytesThreshold = 1 ' 100
        ComPort.WriteTimeout = 100 '500
        ComPort.ReadTimeout = 100 '500
        ' -------------------------------------------- minimum serial buffer is about 65536
        ' ComPort.ReadBufferSize = 4096
        ' ReadBufferSize default is 4096
        ' ReadBufferSize ignores values less than 4096
        ' The ReadBufferSize is the Windows buffer only, 
        ' The BytesToRead property is: SerialPort buffer + Windows buffer (65536 total)
        '
        ' -------------------------------------------- separator used by "ReadLine" (default is LF)
        'ComPort.NewLine = vbCrLf
        ' -------------------------------------------- 
        'ComPort.RtsEnable = False
        'ComPort.DtrEnable = False
        ' --------------------------------------------
        Try
            ComPort.Open()
        Catch
        End Try
    End Sub

    Friend Sub COM_Close()
        If ComPort.IsOpen Then
            ComPort.Close()
        End If
    End Sub

    Friend Function COM_GetPortNames() As String()
        Return SerialPort.GetPortNames()
    End Function

    ' ===================================================================================
    '   DATA RECEIVED EVENT
    ' ===================================================================================
    Private COM_WaitHandle As Threading.EventWaitHandle = _
                              New Threading.EventWaitHandle(False, Threading.EventResetMode.ManualReset)

    Private ResponseLength As Int32

    Private Sub comPort_DataReceived(ByVal sender As Object, _
                                     ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles ComPort.DataReceived
        '
        Try
            If ComPort.BytesToRead >= ResponseLength Then
                COM_WaitHandle.Set()
            End If
        Catch
        End Try
    End Sub

    ' -----------------------------------------------------------------------------------
    '  Calling this sub a thread waits without using CPU and restarts immediately
    ' -----------------------------------------------------------------------------------
    Friend Sub COM_WaitDataReceived(ByVal len As Int32)
        ResponseLength = len
        COM_WaitHandle.Reset()
        COM_WaitHandle.WaitOne(100)
    End Sub

    ' -----------------------------------------------------------------------------------
    '  Call this sub before closing threads and app (near to StopThreadFlag = True)
    ' -----------------------------------------------------------------------------------
    Friend Sub COM_WaitDataReceived_Stop()
        COM_WaitHandle.Set()
    End Sub

End Module
